diff --git a/sysdeps/i386/sysdep.h b/sysdeps/i386/sysdep.h
index d2b0860b99..5cd7f25e0d 100644
--- a/sysdeps/i386/sysdep.h
+++ b/sysdeps/i386/sysdep.h
@@ -16,7 +16,7 @@
    License along with the GNU C Library; if not, see
    <http://www.gnu.org/licenses/>.  */
 
-#include <sysdeps/generic/sysdep.h>
+#include <sysdeps/x86/sysdep.h>
 
 #include <features.h> /* For __GNUC_PREREQ.  */
 
@@ -39,32 +39,6 @@
 
 /* Syntactic details of assembler.  */
 
-/* ELF uses byte-counts for .align, most others use log2 of count of bytes.  */
-#define ALIGNARG(log2) 1<<log2
-#define ASM_SIZE_DIRECTIVE(name) .size name,.-name;
-
-
-/* Define an entry point visible from C.
-
-   There is currently a bug in gdb which prevents us from specifying
-   incomplete stabs information.  Fake some entries here which specify
-   the current source file.  */
-#define	ENTRY(name)							      \
-  .globl C_SYMBOL_NAME(name);						      \
-  .type C_SYMBOL_NAME(name),@function;					      \
-  .align ALIGNARG(4);							      \
-  C_LABEL(name)								      \
-  cfi_startproc;							      \
-  CALL_MCOUNT
-
-#undef	END
-#define END(name)							      \
-  cfi_endproc;								      \
-  ASM_SIZE_DIRECTIVE(name)
-
-#define ENTRY_CHK(name) ENTRY (name)
-#define END_CHK(name) END (name)
-
 /* If compiled for profiling, call `mcount' at the start of each function.  */
 #ifdef	PROF
 /* The mcount code relies on a normal frame pointer being on the stack
@@ -77,12 +51,6 @@
 #define CALL_MCOUNT		/* Do nothing.  */
 #endif
 
-/* Since C identifiers are not normally prefixed with an underscore
-   on this system, the asm identifier `syscall_error' intrudes on the
-   C name space.  Make sure we use an innocuous name.  */
-#define	syscall_error	__syscall_error
-#define mcount		_mcount
-
 #define	PSEUDO(name, syscall_name, args)				      \
   .globl syscall_error;							      \
 lose: SYSCALL_PIC_SETUP							      \
@@ -91,10 +59,6 @@ lose: SYSCALL_PIC_SETUP							      \
   DO_CALL (syscall_name, args);						      \
   jb lose
 
-#undef	PSEUDO_END
-#define	PSEUDO_END(name)						      \
-  END (name)
-
 # define SETUP_PIC_REG(reg) \
   .ifndef GET_PC_THUNK(reg);						      \
   .section .gnu.linkonce.t.GET_PC_THUNK(reg),"ax",@progbits;		      \
@@ -129,13 +93,6 @@ GET_PC_THUNK(reg):							      \
 #define SYSCALL_PIC_SETUP	/* Nothing.  */
 #endif
 
-/* Local label name for asm code. */
-#ifndef L
-#define L(name)		.L##name
-#endif
-
-#define atom_text_section .section ".text.atom", "ax"
-
 #else /* __ASSEMBLER__ */
 
 # define SETUP_PIC_REG_STR(reg)						\
diff --git a/sysdeps/x86/sysdep.h b/sysdeps/x86/sysdep.h
new file mode 100644
index 0000000000..eb25e4b658
--- /dev/null
+++ b/sysdeps/x86/sysdep.h
@@ -0,0 +1,69 @@
+/* Assembler macros for x86.
+   Copyright (C) 2017 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#ifndef _X86_SYSDEP_H
+#define _X86_SYSDEP_H 1
+
+#include <sysdeps/generic/sysdep.h>
+
+#ifdef	__ASSEMBLER__
+
+/* Syntactic details of assembler.  */
+
+/* ELF uses byte-counts for .align, most others use log2 of count of bytes.  */
+#define ALIGNARG(log2) 1<<log2
+#define ASM_SIZE_DIRECTIVE(name) .size name,.-name;
+
+/* Define an entry point visible from C.  */
+#define	ENTRY(name)							      \
+  .globl C_SYMBOL_NAME(name);						      \
+  .type C_SYMBOL_NAME(name),@function;					      \
+  .align ALIGNARG(4);							      \
+  C_LABEL(name)								      \
+  cfi_startproc;							      \
+  CALL_MCOUNT
+
+#undef	END
+#define END(name)							      \
+  cfi_endproc;								      \
+  ASM_SIZE_DIRECTIVE(name)
+
+#define ENTRY_CHK(name) ENTRY (name)
+#define END_CHK(name) END (name)
+
+/* Since C identifiers are not normally prefixed with an underscore
+   on this system, the asm identifier `syscall_error' intrudes on the
+   C name space.  Make sure we use an innocuous name.  */
+#define	syscall_error	__syscall_error
+#define mcount		_mcount
+
+#undef	PSEUDO_END
+#define	PSEUDO_END(name)						      \
+  END (name)
+
+/* Local label name for asm code. */
+#ifndef L
+/* ELF-like local names start with `.L'.  */
+# define L(name)	.L##name
+#endif
+
+#define atom_text_section .section ".text.atom", "ax"
+
+#endif	/* __ASSEMBLER__ */
+
+#endif	/* _X86_SYSDEP_H */
diff --git a/sysdeps/x86_64/sysdep.h b/sysdeps/x86_64/sysdep.h
index 1c52544fa3..4b854754f0 100644
--- a/sysdeps/x86_64/sysdep.h
+++ b/sysdeps/x86_64/sysdep.h
@@ -19,7 +19,7 @@
 #ifndef _X86_64_SYSDEP_H
 #define _X86_64_SYSDEP_H 1
 
-#include <sysdeps/generic/sysdep.h>
+#include <sysdeps/x86/sysdep.h>
 
 #ifdef	__ASSEMBLER__
 
@@ -32,28 +32,6 @@
 #define cfi_offset_rel_rsp(regn, off)	.cfi_escape 0x10, regn, 0x4, 0x13, \
 					0x77, off & 0x7F | 0x80, off >> 7
 
-/* ELF uses byte-counts for .align, most others use log2 of count of bytes.  */
-#define ALIGNARG(log2) 1<<log2
-#define ASM_SIZE_DIRECTIVE(name) .size name,.-name;
-
-
-/* Define an entry point visible from C.  */
-#define	ENTRY(name)							      \
-  .globl C_SYMBOL_NAME(name);						      \
-  .type C_SYMBOL_NAME(name),@function;					      \
-  .align ALIGNARG(4);							      \
-  C_LABEL(name)								      \
-  cfi_startproc;							      \
-  CALL_MCOUNT
-
-#undef	END
-#define END(name)							      \
-  cfi_endproc;								      \
-  ASM_SIZE_DIRECTIVE(name)
-
-#define ENTRY_CHK(name) ENTRY (name)
-#define END_CHK(name) END (name)
-
 /* If compiled for profiling, call `mcount' at the start of each function.  */
 #ifdef	PROF
 /* The mcount code relies on a normal frame pointer being on the stack
@@ -70,12 +48,6 @@
 #define CALL_MCOUNT		/* Do nothing.  */
 #endif
 
-/* Since C identifiers are not normally prefixed with an underscore
-   on this system, the asm identifier `syscall_error' intrudes on the
-   C name space.  Make sure we use an innocuous name.  */
-#define	syscall_error	__syscall_error
-#define mcount		_mcount
-
 #define	PSEUDO(name, syscall_name, args)				      \
 lose:									      \
   jmp JUMPTARGET(syscall_error)						      \
@@ -84,10 +56,6 @@ lose:									      \
   DO_CALL (syscall_name, args);						      \
   jb lose
 
-#undef	PSEUDO_END
-#define	PSEUDO_END(name)						      \
-  END (name)
-
 #undef JUMPTARGET
 #ifdef SHARED
 # ifdef BIND_NOW
@@ -100,14 +68,6 @@ lose:									      \
 # define JUMPTARGET(name)	name
 #endif
 
-/* Local label name for asm code. */
-#ifndef L
-/* ELF-like local names start with `.L'.  */
-# define L(name)	.L##name
-#endif
-
-#define atom_text_section .section ".text.atom", "ax"
-
 /* Long and pointer size in bytes.  */
 #define LP_SIZE	8
 